/*
 * myLibS3.cpp
 *
 *  Created on: Jun 28, 2014
 *      Author: nick
 */



#include "myLibS3.h"
#include "myListObj.h"
#include "myGetObj.h"
#include "myPutObj.h"
#include "myDir.h"
#include "myS3Common.h"

using namespace std;



void test1()
{
	S3ObjSet s3Set;
	string strBucket = "diabloforum";
	if (listObjects(strBucket, s3Set))
	{
		//cout << "successfully get "<< s3Vect.size() << " objects of bucket of " << strBucket << endl;
		printS3ObjSet(s3Set);
	}
}

void test2()
{
	if (getObject("diabloforum", "rules.txt", "nick-test.txt"))
	{
		cout << " successful " << endl;
	}
}

void test3()
{
	if (putObject("nickhuang99", "rules.txt", "./nick.txt"))
	{
		cout << " successful" << endl;
	}
}

void test4()
{
	S3ObjSet s3List;
	if (getAllFiles("/home/nick/Downloads/diabloforum/public_html", s3List))
	{
		cout << " successful " << endl;
		printS3ObjSet(s3List);
	}
}

void test5()
{
	const string& strBucket = "diabloforum";
	const string& strRootPath = "/home/nick/Downloads/diabloforum/public_html/";

	S3ObjSet localList, remoteList;
	if (!getAllFiles(strRootPath, localList))
	{
		cout << " getAllFiles failed " << endl;
		return;
	}
	if (!listObjects(strBucket, remoteList))
	{
		cout << " listObjects failed " << endl;
		return;
	}
	//printS3ObjSet(localList);
	//printS3ObjSet(remoteList);

	for (S3ObjSet::const_iterator localIt = localList.begin(); localIt != localList.end(); localIt ++)
	{
		SyncDirectionEnum direction = DirectionNone; // nothing
		S3Obj searchObj;

		S3ObjSet::const_iterator remoteIt = remoteList.find(*localIt);
		if (remoteIt != remoteList.end())
		{
			// found it
			if (remoteIt->size != localIt->size || (remoteIt->tag.size() != 0 && remoteIt->tag.compare(localIt->tag) != 0))
			{
				direction = DirectionUpload;
			}
		}
		else
		{
			direction = DirectionUpload; // upload
		}
		string strPath = strRootPath + localIt->key;
		string strPersonal = strRootPath + "personal";
		S3CannedAcl acl = S3CannedAclPublicRead;
		switch (direction)
		{
		case DirectionUpload:
			if (strPath.compare(0, strPersonal.size(), strPersonal) == 0)
			{
				acl = S3CannedAclPrivate;
			}
			if (!putObject(strBucket, localIt->key, strPath, acl))
			{
				cout << "upload error: bucket: " << strBucket << " key:" << strPath << " path:" << localIt->key << endl;
			}
			break;
		case DirectionDownload:

			if (!getObject(strBucket, localIt->key, strPath))
			{
				cout << "download error: bucket: " << strBucket << " key:" << strPath << " path:" << localIt->key << endl;
			}
			break;
		default:

			break;
		}
	}
}

int main()
{
	test5();

	return 0;

}


